# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'ListEndpointKeysResult',
    'AwaitableListEndpointKeysResult',
    'list_endpoint_keys',
    'list_endpoint_keys_output',
]

@pulumi.output_type
class ListEndpointKeysResult:
    def __init__(__self__, keys=None):
        if keys and not isinstance(keys, dict):
            raise TypeError("Expected argument 'keys' to be a dict")
        pulumi.set(__self__, "keys", keys)

    @property
    @pulumi.getter
    def keys(self) -> Optional['outputs.AccountApiKeysResponse']:
        """
        Dictionary of Keys for the endpoint.
        """
        return pulumi.get(self, "keys")


class AwaitableListEndpointKeysResult(ListEndpointKeysResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListEndpointKeysResult(
            keys=self.keys)


def list_endpoint_keys(endpoint_name: Optional[str] = None,
                       resource_group_name: Optional[str] = None,
                       workspace_name: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListEndpointKeysResult:
    """
    Use this data source to access information about an existing resource.

    :param str endpoint_name: Name of the endpoint resource.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str workspace_name: Azure Machine Learning Workspace Name
    """
    __args__ = dict()
    __args__['endpointName'] = endpoint_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:machinelearningservices/v20240401preview:listEndpointKeys', __args__, opts=opts, typ=ListEndpointKeysResult).value

    return AwaitableListEndpointKeysResult(
        keys=pulumi.get(__ret__, 'keys'))


@_utilities.lift_output_func(list_endpoint_keys)
def list_endpoint_keys_output(endpoint_name: Optional[pulumi.Input[str]] = None,
                              resource_group_name: Optional[pulumi.Input[str]] = None,
                              workspace_name: Optional[pulumi.Input[str]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ListEndpointKeysResult]:
    """
    Use this data source to access information about an existing resource.

    :param str endpoint_name: Name of the endpoint resource.
    :param str resource_group_name: The name of the resource group. The name is case insensitive.
    :param str workspace_name: Azure Machine Learning Workspace Name
    """
    ...
